<?php

 session_start();

define("ACL_LOCATION","/etc/squid3/whitelists/whitelisted_domains.acl");
define("SQUID_BINARY","/usr/sbin/squid3");
define("SQUID_CHECK","-k parse");
define("SQUID_RECONFIGURE","-k reconfigure");
define("HEADING","whitelisted_domains");
define("LINK_BACK","./index.html");
define("LINK_NAME","Hauptseite Proxy Liste");


openlog("proxy-web:".HEADING,LOG_PID | LOG_PERROR, LOG_DAEMON);



function getTargets()
{
        $targets=file_get_contents(ACL_LOCATION) or die ("Could not read ACL_LOCATION");

        return $targets;
}

function checkConfig()
{
  if(!isset($_SERVER['PHP_AUTH_USER']))
  {

          syslog(LOG_ALERT,"No User Authentication: ".$_SERVER['REMOTE_ADDR']);
      die("No User Authentication sent. You must require htaccess Authentication");
      
  }

  if(! is_readable(ACL_LOCATION))
       die("Cannot read ACL_LOCATION please check");
  if(!is_writeable(ACL_LOCATION))
       die("Cannot write ACL_LOCATION please check");
   if(!is_readable(SQUID_BINARY))
       die("Cannot read SQUID binary");

}


function checkUpdate()
{

	if( isset($_POST['acl_content']) && strlen($_POST['acl_content'])>1 )
	{
                $targets_old=getTargets();
                $targets_new=$_POST['acl_content'];


          //Here we could implement check of each element against regex ? explode array by \n and check each element
          //Hostname regex ValidHostnameRegex = "^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$"; 


           $targets_new=explode("\n",$targets_new) or die("Internal Error - please contact system administrator");

           $targets_new=array_unique($targets_new) or die("Internal Error - please contact system administrator");
           
           $targetsString="";
            for($i=0;  $i<count($targets_new);$i++)
            {
              if(isset($targets_new[$i]))
              {
               // https://stackoverflow.com/questions/1176904/php-how-to-remove-all-non-printable-characters-in-a-string/28970891
                  $targets_new[$i]=preg_replace('/[\x00-\x1F\x7F]/u', '', $targets_new[$i]);
               
                  $targetsString.=$targets_new[$i]."\n";
              }
            }
            

           $targets_new=$targetsString;


           if(!file_put_contents(ACL_LOCATION,$targets_new))
           {
               if(file_put_contents($targets_old))
               {
                echo "Could not write new Elements. Successfully Restored old Elements";

               }
	       else
               {
               echo "Could not write new Elements. Could NOT restore old Elements!!";
               }
           }
           else
           {
                      exec("sudo ".SQUID_BINARY." ".SQUID_CHECK,$output,$return_code);
                    syslog(LOG_NOTICE,"Trying to verify new targets. User:".$_SERVER['PHP_AUTH_USER']);

                    if($return_code==0)
		    {
                        exec("sudo ".SQUID_BINARY." ".SQUID_RECONFIGURE,$output,$return_code);
                     if($return_code==0)
                     {
                      echo "successfully updated and reloaded Proxy Elements";
                      syslog(LOG_NOTICE,"Successfully updated targets. User:".$_SERVER['PHP_AUTH_USER']);
		     }
		     else
                     {
                      if(!file_put_contents(ACL_LOCATION,$targets_old))
                      {
			echo "Problems reconfiguring Proxy. Could not restore old Elements. Please contact system administrator";

		      }
		      else
 		      {
                        echo "Problems reconfiguring Proxy. Restored old Elements. Please contact system administrator";
                      
 		      }
                      exec("sudo ".SQUID_BINARY." ".SQUID_RECONFIGURE,$output,$return_code);
		     }


		    }
                    else
                    {
                         syslog(LOG_ALERT,"Problems parsing ACL. User:".$_SERVER['PHP_AUTH_USER']);

                      if(!file_put_contents(ACL_LOCATION,$targets_old))
                      {
                        echo "Problems parsing Proxy ACL. Could not restore old Elements.";

                      }
                      else
                      {
                        echo "Problems parsing Proxy ACL . Restored old Elements.";
                      }

                     
                    }
  


           }


	}
}


function checkAction()
{

checkConfig();
checkUpdate();


}



?>


<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Christian Czeczil">
    <link rel="icon" href="../../favicon.ico">

    <title><?php echo HEADING ?></title>

    <!-- Bootstrap core CSS -->
    <link href="bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <!-- Bootstrap theme -->
    <link href="boostrap/css/bootstrap-theme.min.css" rel="stylesheet">
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <link href="assets/css/ie10-viewport-bug-workaround.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="theme.css" rel="stylesheet">

<script>

function disableButton()
{



document.getElementById("Update").disabled = true;

return true;


}
</script>


  </head>

  <body>



    <div class="container theme-showcase" role="main">

      <!-- Main jumbotron for a primary marketing message or call to action -->
      <div class="jumbotron">
        <h1><?php echo HEADING ?></h1>
      </div>

  <table class="table table-hover">
  <thead>
   <tr><th>Status</th></tr>
  </thead>
   <tr><td><?php checkAction(); ?></td></tr>
  </table>


<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="POST" onsubmit="return disableButton();">
   <table class="table table-hover">
            <thead>
              <tr>
                <th>Liste</th>
              </tr>
            </thead>
            <tbody>
          <tr><td> <textarea class="form-control" rows="15" id="acl_content" name="acl_content"><?php echo getTargets(); ?></textarea></td></tr>
          <tr><td> <button type="submit" class="btn btn-default" id="Update" name="Update">Aktualisieren</button></td></tr>
           <tr><td><a href="<?php echo LINK_BACK?>" class="btn btn-default" role="button"><?php echo LINK_NAME?></a></td></tr>
              </tbody>
          </table>
  </form>
  </body>
</html>
